package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLScheduleSequenceNode_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLScheduleSequenceNode extends ISLScheduleNode  {
	
	/* @generated */
	protected ISLScheduleSequenceNode(long ptr) {
		/*** PROTECTED REGION ID(ISLScheduleSequenceNode_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLScheduleSequenceNode build(long ptr) {
		return new ISLScheduleSequenceNode(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLScheduleSequenceNode_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_schedule_node_sequence_splice_child 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLScheduleSequenceNode spliceChild(int pos) {
		/*** PROTECTED REGION ID(isl_schedule_node_sequence_splice_child) DISABLED START ***/
		ISLScheduleSequenceNode res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = (ISLScheduleSequenceNode)ISLScheduleSequenceNode.build(ISLNative.isl_schedule_node_sequence_splice_child(getNativePtr(this), pos));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public void accept(IISLScheduleNodeVisitor visitor) {
		visitor.visitISLScheduleSequenceNode(this);
	}
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLScheduleSequenceNode_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
